/*----- PROTECTED REGION ID(TestMemoryLeak.cpp) ENABLED START -----*/
static const char *RcsId = "$Id:  $";
//=============================================================================
//
// file :        TestMemoryLeak.cpp
//
// description : C++ source for the TestMemoryLeak class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               TestMemoryLeak are implemented in this file.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <TestMemoryLeak.h>
#include <TestMemoryLeakClass.h>

/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak.cpp

/**
 *  TestMemoryLeak class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  speed      |  Tango::DevDouble	Scalar
//  windSpeed  |  Tango::DevDouble	Scalar
//================================================================

namespace TestMemoryLeak_ns
{
/*----- PROTECTED REGION ID(TestMemoryLeak::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : TestMemoryLeak::TestMemoryLeak()
 *	Description : Constructors for a Tango device
 *                implementing the classTestMemoryLeak
 */
//--------------------------------------------------------
TestMemoryLeak::TestMemoryLeak(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(TestMemoryLeak::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::constructor_1
}
//--------------------------------------------------------
TestMemoryLeak::TestMemoryLeak(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(TestMemoryLeak::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::constructor_2
}
//--------------------------------------------------------
TestMemoryLeak::TestMemoryLeak(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(TestMemoryLeak::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : TestMemoryLeak::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void TestMemoryLeak::delete_device()
{
	DEBUG_STREAM << "TestMemoryLeak::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(TestMemoryLeak::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	
	/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::delete_device
	delete[] attr_speed_read;
	delete[] attr_windSpeed_read;
}

//--------------------------------------------------------
/**
 *	Method      : TestMemoryLeak::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void TestMemoryLeak::init_device()
{
	DEBUG_STREAM << "TestMemoryLeak::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(TestMemoryLeak::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	
	/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::init_device_before
	
	//	No device property to be read from database
	
	attr_speed_read = new Tango::DevDouble[1];
	attr_windSpeed_read = new Tango::DevDouble[1];

	/*----- PROTECTED REGION ID(TestMemoryLeak::init_device) ENABLED START -----*/
	
	//	Initialize device
	
	/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::init_device
}


//--------------------------------------------------------
/**
 *	Method      : TestMemoryLeak::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void TestMemoryLeak::always_executed_hook()
{
	INFO_STREAM << "TestMemoryLeak::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(TestMemoryLeak::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	
	/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : TestMemoryLeak::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void TestMemoryLeak::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "TestMemoryLeak::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(TestMemoryLeak::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : TestMemoryLeak::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void TestMemoryLeak::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "TestMemoryLeak::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(TestMemoryLeak::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute speed related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void TestMemoryLeak::read_speed(Tango::Attribute &attr)
{
	DEBUG_STREAM << "TestMemoryLeak::read_speed(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(TestMemoryLeak::read_speed) ENABLED START -----*/
	//	Set the attribute value
	//attr.set_value(attr_speed_read);
	
	/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::read_speed
}
//--------------------------------------------------------
/**
 *	Write attribute speed related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void TestMemoryLeak::write_speed(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "TestMemoryLeak::write_speed(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(TestMemoryLeak::write_speed) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::write_speed
}
//--------------------------------------------------------
/**
 *	Read attribute windSpeed related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void TestMemoryLeak::read_windSpeed(Tango::Attribute &attr)
{
	DEBUG_STREAM << "TestMemoryLeak::read_windSpeed(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(TestMemoryLeak::read_windSpeed) ENABLED START -----*/
	//	Set the attribute value
	//attr.set_value(attr_windSpeed_read);
	
	/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::read_windSpeed
}

//--------------------------------------------------------
/**
 *	Method      : TestMemoryLeak::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void TestMemoryLeak::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(TestMemoryLeak::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::add_dynamic_attributes
}


/*----- PROTECTED REGION ID(TestMemoryLeak::namespace_ending) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	TestMemoryLeak::namespace_ending
} //	namespace
